/*
 * This file automatically produced by mprep from:
 *	opencvlink.tm
 * mprep Revision 16 Copyright (c) Wolfram Research, Inc. 1990-2009
 */

#define MPREP_REVISION 16

#include "mathlink.h"

int MLAbort = 0;
int MLDone  = 0;
long MLSpecialCharacter = '\0';

MLINK stdlink = 0;
MLEnvironment stdenv = 0;
#if MLINTERFACE >= 3
MLYieldFunctionObject stdyielder = (MLYieldFunctionObject)0;
MLMessageHandlerObject stdhandler = (MLMessageHandlerObject)0;
#else
MLYieldFunctionObject stdyielder = 0;
MLMessageHandlerObject stdhandler = 0;
#endif /* MLINTERFACE >= 3 */

/********************************* end header *********************************/


void cv_open P(( void));

#if MLPROTOTYPES
static int _tr0( MLINK mlp)
#else
static int _tr0(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	if ( ! MLNewPacket(mlp) ) goto L0;
	if( !mlp) return res; /* avoid unused parameter warning */

	cv_open();

	res = 1;

L0:	return res;
} /* _tr0 */


void cv_close P(( void));

#if MLPROTOTYPES
static int _tr1( MLINK mlp)
#else
static int _tr1(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	if ( ! MLNewPacket(mlp) ) goto L0;
	if( !mlp) return res; /* avoid unused parameter warning */

	cv_close();

	res = 1;

L0:	return res;
} /* _tr1 */


void cv_create_image P(( int * _tp1, long _tpl1, int _tp2, int _tp3));

#if MLPROTOTYPES
static int _tr2( MLINK mlp)
#else
static int _tr2(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int * _tp1;
	long _tpl1;
	int _tp2;
	int _tp3;
	if ( ! MLGetIntegerList( mlp, &_tp1, &_tpl1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetInteger( mlp, &_tp3) ) goto L2;
	if ( ! MLNewPacket(mlp) ) goto L3;

	cv_create_image(_tp1, _tpl1, _tp2, _tp3);

	res = 1;
L3: L2: L1:	MLDisownIntegerList( mlp, _tp1, _tpl1);

L0:	return res;
} /* _tr2 */


void cv_release_image P(( int _tp1));

#if MLPROTOTYPES
static int _tr3( MLINK mlp)
#else
static int _tr3(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLNewPacket(mlp) ) goto L1;

	cv_release_image(_tp1);

	res = 1;
L1: 
L0:	return res;
} /* _tr3 */


void cv_image_info P(( int _tp1));

#if MLPROTOTYPES
static int _tr4( MLINK mlp)
#else
static int _tr4(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLNewPacket(mlp) ) goto L1;

	cv_image_info(_tp1);

	res = 1;
L1: 
L0:	return res;
} /* _tr4 */


void cv_create_mem_storage P(( int _tp1));

#if MLPROTOTYPES
static int _tr5( MLINK mlp)
#else
static int _tr5(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLNewPacket(mlp) ) goto L1;

	cv_create_mem_storage(_tp1);

	res = 1;
L1: 
L0:	return res;
} /* _tr5 */


void cv_get_seq_hnext P(( int _tp1));

#if MLPROTOTYPES
static int _tr6( MLINK mlp)
#else
static int _tr6(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLNewPacket(mlp) ) goto L1;

	cv_get_seq_hnext(_tp1);

	res = 1;
L1: 
L0:	return res;
} /* _tr6 */


void cv_get_seq_hprev P(( int _tp1));

#if MLPROTOTYPES
static int _tr7( MLINK mlp)
#else
static int _tr7(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLNewPacket(mlp) ) goto L1;

	cv_get_seq_hprev(_tp1);

	res = 1;
L1: 
L0:	return res;
} /* _tr7 */


void cv_get_seq_vnext P(( int _tp1));

#if MLPROTOTYPES
static int _tr8( MLINK mlp)
#else
static int _tr8(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLNewPacket(mlp) ) goto L1;

	cv_get_seq_vnext(_tp1);

	res = 1;
L1: 
L0:	return res;
} /* _tr8 */


void cv_get_seq_vprev P(( int _tp1));

#if MLPROTOTYPES
static int _tr9( MLINK mlp)
#else
static int _tr9(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLNewPacket(mlp) ) goto L1;

	cv_get_seq_vprev(_tp1);

	res = 1;
L1: 
L0:	return res;
} /* _tr9 */


void cv_get_seq_size P(( int _tp1));

#if MLPROTOTYPES
static int _tr10( MLINK mlp)
#else
static int _tr10(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLNewPacket(mlp) ) goto L1;

	cv_get_seq_size(_tp1);

	res = 1;
L1: 
L0:	return res;
} /* _tr10 */


void cv_create_mat P(( int _tp1, int _tp2, int _tp3, int _tp4));

#if MLPROTOTYPES
static int _tr11( MLINK mlp)
#else
static int _tr11(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int _tp2;
	int _tp3;
	int _tp4;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetInteger( mlp, &_tp3) ) goto L2;
	if ( ! MLGetInteger( mlp, &_tp4) ) goto L3;
	if ( ! MLNewPacket(mlp) ) goto L4;

	cv_create_mat(_tp1, _tp2, _tp3, _tp4);

	res = 1;
L4: L3: L2: L1: 
L0:	return res;
} /* _tr11 */


void cv_create_mat_header P(( int _tp1, int _tp2, int _tp3, int _tp4));

#if MLPROTOTYPES
static int _tr12( MLINK mlp)
#else
static int _tr12(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int _tp2;
	int _tp3;
	int _tp4;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetInteger( mlp, &_tp3) ) goto L2;
	if ( ! MLGetInteger( mlp, &_tp4) ) goto L3;
	if ( ! MLNewPacket(mlp) ) goto L4;

	cv_create_mat_header(_tp1, _tp2, _tp3, _tp4);

	res = 1;
L4: L3: L2: L1: 
L0:	return res;
} /* _tr12 */


void cv_get_size P(( int _tp1));

#if MLPROTOTYPES
static int _tr13( MLINK mlp)
#else
static int _tr13(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLNewPacket(mlp) ) goto L1;

	cv_get_size(_tp1);

	res = 1;
L1: 
L0:	return res;
} /* _tr13 */


void cv_get_row P(( int _tp1, int _tp2, int _tp3));

#if MLPROTOTYPES
static int _tr14( MLINK mlp)
#else
static int _tr14(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int _tp2;
	int _tp3;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetInteger( mlp, &_tp3) ) goto L2;
	if ( ! MLNewPacket(mlp) ) goto L3;

	cv_get_row(_tp1, _tp2, _tp3);

	res = 1;
L3: L2: L1: 
L0:	return res;
} /* _tr14 */


void cv_get_col P(( int _tp1, int _tp2, int _tp3));

#if MLPROTOTYPES
static int _tr15( MLINK mlp)
#else
static int _tr15(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int _tp2;
	int _tp3;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetInteger( mlp, &_tp3) ) goto L2;
	if ( ! MLNewPacket(mlp) ) goto L3;

	cv_get_col(_tp1, _tp2, _tp3);

	res = 1;
L3: L2: L1: 
L0:	return res;
} /* _tr15 */


void cv_get_sub_rect P(( int _tp1, int _tp2, int * _tp3, long _tpl3));

#if MLPROTOTYPES
static int _tr16( MLINK mlp)
#else
static int _tr16(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int _tp2;
	int * _tp3;
	long _tpl3;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetIntegerList( mlp, &_tp3, &_tpl3) ) goto L2;
	if ( ! MLNewPacket(mlp) ) goto L3;

	cv_get_sub_rect(_tp1, _tp2, _tp3, _tpl3);

	res = 1;
L3:	MLDisownIntegerList( mlp, _tp3, _tpl3);
L2: L1: 
L0:	return res;
} /* _tr16 */


void cv_min_max_loc P(( int _tp1));

#if MLPROTOTYPES
static int _tr17( MLINK mlp)
#else
static int _tr17(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLNewPacket(mlp) ) goto L1;

	cv_min_max_loc(_tp1);

	res = 1;
L1: 
L0:	return res;
} /* _tr17 */


void cv_convert_scale P(( int _tp1, int _tp2, double _tp3, double _tp4));

#if MLPROTOTYPES
static int _tr18( MLINK mlp)
#else
static int _tr18(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int _tp2;
	double _tp3;
	double _tp4;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetReal( mlp, &_tp3) ) goto L2;
	if ( ! MLGetReal( mlp, &_tp4) ) goto L3;
	if ( ! MLNewPacket(mlp) ) goto L4;

	cv_convert_scale(_tp1, _tp2, _tp3, _tp4);

	res = 1;
L4: L3: L2: L1: 
L0:	return res;
} /* _tr18 */


void cv_copy P(( int _tp1, int _tp2, int _tp3));

#if MLPROTOTYPES
static int _tr19( MLINK mlp)
#else
static int _tr19(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int _tp2;
	int _tp3;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetInteger( mlp, &_tp3) ) goto L2;
	if ( ! MLNewPacket(mlp) ) goto L3;

	cv_copy(_tp1, _tp2, _tp3);

	res = 1;
L3: L2: L1: 
L0:	return res;
} /* _tr19 */


void cv_get_image_array P(( int _tp1, int _tp2, int _tp3));

#if MLPROTOTYPES
static int _tr20( MLINK mlp)
#else
static int _tr20(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int _tp2;
	int _tp3;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetInteger( mlp, &_tp3) ) goto L2;
	if ( ! MLNewPacket(mlp) ) goto L3;

	cv_get_image_array(_tp1, _tp2, _tp3);

	res = 1;
L3: L2: L1: 
L0:	return res;
} /* _tr20 */


void cv_get_int_image_array P(( int _tp1));

#if MLPROTOTYPES
static int _tr21( MLINK mlp)
#else
static int _tr21(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLNewPacket(mlp) ) goto L1;

	cv_get_int_image_array(_tp1);

	res = 1;
L1: 
L0:	return res;
} /* _tr21 */


void cv_get_int_frame_array P(( int _tp1, int _tp2));

#if MLPROTOTYPES
static int _tr22( MLINK mlp)
#else
static int _tr22(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int _tp2;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLNewPacket(mlp) ) goto L2;

	cv_get_int_frame_array(_tp1, _tp2);

	res = 1;
L2: L1: 
L0:	return res;
} /* _tr22 */


void cv_get_array P(( int _tp1, int _tp2));

#if MLPROTOTYPES
static int _tr23( MLINK mlp)
#else
static int _tr23(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int _tp2;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLNewPacket(mlp) ) goto L2;

	cv_get_array(_tp1, _tp2);

	res = 1;
L2: L1: 
L0:	return res;
} /* _tr23 */


void cv_set_array P(( int _tp1, int _tp2));

#if MLPROTOTYPES
static int _tr24( MLINK mlp)
#else
static int _tr24(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int _tp2;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;

	cv_set_array(_tp1, _tp2);

	res = 1;
 L1: 
L0:	return res;
} /* _tr24 */


void cv_set_image_roi P(( int _tp1, int * _tp2, long _tpl2));

#if MLPROTOTYPES
static int _tr25( MLINK mlp)
#else
static int _tr25(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int * _tp2;
	long _tpl2;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetIntegerList( mlp, &_tp2, &_tpl2) ) goto L1;
	if ( ! MLNewPacket(mlp) ) goto L2;

	cv_set_image_roi(_tp1, _tp2, _tpl2);

	res = 1;
L2:	MLDisownIntegerList( mlp, _tp2, _tpl2);
L1: 
L0:	return res;
} /* _tr25 */


void cv_reset_image_roi P(( int _tp1));

#if MLPROTOTYPES
static int _tr26( MLINK mlp)
#else
static int _tr26(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLNewPacket(mlp) ) goto L1;

	cv_reset_image_roi(_tp1);

	res = 1;
L1: 
L0:	return res;
} /* _tr26 */


void cv_split P(( int _tp1, int _tp2, int _tp3, int _tp4, int _tp5));

#if MLPROTOTYPES
static int _tr27( MLINK mlp)
#else
static int _tr27(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int _tp2;
	int _tp3;
	int _tp4;
	int _tp5;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetInteger( mlp, &_tp3) ) goto L2;
	if ( ! MLGetInteger( mlp, &_tp4) ) goto L3;
	if ( ! MLGetInteger( mlp, &_tp5) ) goto L4;
	if ( ! MLNewPacket(mlp) ) goto L5;

	cv_split(_tp1, _tp2, _tp3, _tp4, _tp5);

	res = 1;
L5: L4: L3: L2: L1: 
L0:	return res;
} /* _tr27 */


void cv_xy_mean P(( int _tp1, int * _tp2, long _tpl2));

#if MLPROTOTYPES
static int _tr28( MLINK mlp)
#else
static int _tr28(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int * _tp2;
	long _tpl2;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetIntegerList( mlp, &_tp2, &_tpl2) ) goto L1;
	if ( ! MLNewPacket(mlp) ) goto L2;

	cv_xy_mean(_tp1, _tp2, _tpl2);

	res = 1;
L2:	MLDisownIntegerList( mlp, _tp2, _tpl2);
L1: 
L0:	return res;
} /* _tr28 */


void cv_filter_2d P(( int _tp1, int _tp2, int _tp3));

#if MLPROTOTYPES
static int _tr29( MLINK mlp)
#else
static int _tr29(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int _tp2;
	int _tp3;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetInteger( mlp, &_tp3) ) goto L2;
	if ( ! MLNewPacket(mlp) ) goto L3;

	cv_filter_2d(_tp1, _tp2, _tp3);

	res = 1;
L3: L2: L1: 
L0:	return res;
} /* _tr29 */


void cv_laplace P(( int _tp1, int _tp2, int _tp3));

#if MLPROTOTYPES
static int _tr30( MLINK mlp)
#else
static int _tr30(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int _tp2;
	int _tp3;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetInteger( mlp, &_tp3) ) goto L2;
	if ( ! MLNewPacket(mlp) ) goto L3;

	cv_laplace(_tp1, _tp2, _tp3);

	res = 1;
L3: L2: L1: 
L0:	return res;
} /* _tr30 */


void cv_sobel P(( int _tp1, int _tp2, int _tp3, int _tp4, int _tp5));

#if MLPROTOTYPES
static int _tr31( MLINK mlp)
#else
static int _tr31(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int _tp2;
	int _tp3;
	int _tp4;
	int _tp5;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetInteger( mlp, &_tp3) ) goto L2;
	if ( ! MLGetInteger( mlp, &_tp4) ) goto L3;
	if ( ! MLGetInteger( mlp, &_tp5) ) goto L4;
	if ( ! MLNewPacket(mlp) ) goto L5;

	cv_sobel(_tp1, _tp2, _tp3, _tp4, _tp5);

	res = 1;
L5: L4: L3: L2: L1: 
L0:	return res;
} /* _tr31 */


void cv_smooth P(( int _tp1, int _tp2, int _tp3, int _tp4, int _tp5, double _tp6));

#if MLPROTOTYPES
static int _tr32( MLINK mlp)
#else
static int _tr32(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int _tp2;
	int _tp3;
	int _tp4;
	int _tp5;
	double _tp6;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetInteger( mlp, &_tp3) ) goto L2;
	if ( ! MLGetInteger( mlp, &_tp4) ) goto L3;
	if ( ! MLGetInteger( mlp, &_tp5) ) goto L4;
	if ( ! MLGetReal( mlp, &_tp6) ) goto L5;
	if ( ! MLNewPacket(mlp) ) goto L6;

	cv_smooth(_tp1, _tp2, _tp3, _tp4, _tp5, _tp6);

	res = 1;
L6: L5: L4: L3: L2: L1: 
L0:	return res;
} /* _tr32 */


void cv_cvt_color P(( int _tp1, int _tp2, int _tp3));

#if MLPROTOTYPES
static int _tr33( MLINK mlp)
#else
static int _tr33(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int _tp2;
	int _tp3;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetInteger( mlp, &_tp3) ) goto L2;
	if ( ! MLNewPacket(mlp) ) goto L3;

	cv_cvt_color(_tp1, _tp2, _tp3);

	res = 1;
L3: L2: L1: 
L0:	return res;
} /* _tr33 */


void cv_draw_contours P(( int _tp1, int _tp2, int * _tp3, long _tpl3, int * _tp4, long _tpl4, int _tp5, int _tp6, int _tp7, int * _tp8, long _tpl8));

#if MLPROTOTYPES
static int _tr34( MLINK mlp)
#else
static int _tr34(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int _tp2;
	int * _tp3;
	long _tpl3;
	int * _tp4;
	long _tpl4;
	int _tp5;
	int _tp6;
	int _tp7;
	int * _tp8;
	long _tpl8;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetIntegerList( mlp, &_tp3, &_tpl3) ) goto L2;
	if ( ! MLGetIntegerList( mlp, &_tp4, &_tpl4) ) goto L3;
	if ( ! MLGetInteger( mlp, &_tp5) ) goto L4;
	if ( ! MLGetInteger( mlp, &_tp6) ) goto L5;
	if ( ! MLGetInteger( mlp, &_tp7) ) goto L6;
	if ( ! MLGetIntegerList( mlp, &_tp8, &_tpl8) ) goto L7;
	if ( ! MLNewPacket(mlp) ) goto L8;

	cv_draw_contours(_tp1, _tp2, _tp3, _tpl3, _tp4, _tpl4, _tp5, _tp6, _tp7, _tp8, _tpl8);

	res = 1;
L8:	MLDisownIntegerList( mlp, _tp8, _tpl8);
L7: L6: L5: L4:	MLDisownIntegerList( mlp, _tp4, _tpl4);
L3:	MLDisownIntegerList( mlp, _tp3, _tpl3);
L2: L1: 
L0:	return res;
} /* _tr34 */


void cv_rectangle P(( int _tp1, int * _tp2, long _tpl2, int * _tp3, long _tpl3, int _tp4));

#if MLPROTOTYPES
static int _tr35( MLINK mlp)
#else
static int _tr35(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int * _tp2;
	long _tpl2;
	int * _tp3;
	long _tpl3;
	int _tp4;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetIntegerList( mlp, &_tp2, &_tpl2) ) goto L1;
	if ( ! MLGetIntegerList( mlp, &_tp3, &_tpl3) ) goto L2;
	if ( ! MLGetInteger( mlp, &_tp4) ) goto L3;
	if ( ! MLNewPacket(mlp) ) goto L4;

	cv_rectangle(_tp1, _tp2, _tpl2, _tp3, _tpl3, _tp4);

	res = 1;
L4: L3:	MLDisownIntegerList( mlp, _tp3, _tpl3);
L2:	MLDisownIntegerList( mlp, _tp2, _tpl2);
L1: 
L0:	return res;
} /* _tr35 */


void cv_create_hist P(( int * _tp1, long _tpl1, int _tp2));

#if MLPROTOTYPES
static int _tr36( MLINK mlp)
#else
static int _tr36(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int * _tp1;
	long _tpl1;
	int _tp2;
	if ( ! MLGetIntegerList( mlp, &_tp1, &_tpl1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;

	cv_create_hist(_tp1, _tpl1, _tp2);

	res = 1;
 L1:	MLDisownIntegerList( mlp, _tp1, _tpl1);

L0:	return res;
} /* _tr36 */


void cv_calc_back_project P(( int * _tp1, long _tpl1, int _tp2, int _tp3));

#if MLPROTOTYPES
static int _tr37( MLINK mlp)
#else
static int _tr37(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int * _tp1;
	long _tpl1;
	int _tp2;
	int _tp3;
	if ( ! MLGetIntegerList( mlp, &_tp1, &_tpl1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetInteger( mlp, &_tp3) ) goto L2;
	if ( ! MLNewPacket(mlp) ) goto L3;

	cv_calc_back_project(_tp1, _tpl1, _tp2, _tp3);

	res = 1;
L3: L2: L1:	MLDisownIntegerList( mlp, _tp1, _tpl1);

L0:	return res;
} /* _tr37 */


void cv_calc_hist P(( int * _tp1, long _tpl1, int _tp2, int _tp3, int _tp4));

#if MLPROTOTYPES
static int _tr38( MLINK mlp)
#else
static int _tr38(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int * _tp1;
	long _tpl1;
	int _tp2;
	int _tp3;
	int _tp4;
	if ( ! MLGetIntegerList( mlp, &_tp1, &_tpl1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetInteger( mlp, &_tp3) ) goto L2;
	if ( ! MLGetInteger( mlp, &_tp4) ) goto L3;
	if ( ! MLNewPacket(mlp) ) goto L4;

	cv_calc_hist(_tp1, _tpl1, _tp2, _tp3, _tp4);

	res = 1;
L4: L3: L2: L1:	MLDisownIntegerList( mlp, _tp1, _tpl1);

L0:	return res;
} /* _tr38 */


void cv_get_hist_array P(( int _tp1));

#if MLPROTOTYPES
static int _tr39( MLINK mlp)
#else
static int _tr39(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLNewPacket(mlp) ) goto L1;

	cv_get_hist_array(_tp1);

	res = 1;
L1: 
L0:	return res;
} /* _tr39 */


void cv_get_minmax_hist_value P(( int _tp1));

#if MLPROTOTYPES
static int _tr40( MLINK mlp)
#else
static int _tr40(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLNewPacket(mlp) ) goto L1;

	cv_get_minmax_hist_value(_tp1);

	res = 1;
L1: 
L0:	return res;
} /* _tr40 */


void cv_normalize_hist P(( int _tp1, double _tp2));

#if MLPROTOTYPES
static int _tr41( MLINK mlp)
#else
static int _tr41(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	double _tp2;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetReal( mlp, &_tp2) ) goto L1;
	if ( ! MLNewPacket(mlp) ) goto L2;

	cv_normalize_hist(_tp1, _tp2);

	res = 1;
L2: L1: 
L0:	return res;
} /* _tr41 */


void cv_thresh_hist P(( int _tp1, double _tp2));

#if MLPROTOTYPES
static int _tr42( MLINK mlp)
#else
static int _tr42(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	double _tp2;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetReal( mlp, &_tp2) ) goto L1;
	if ( ! MLNewPacket(mlp) ) goto L2;

	cv_thresh_hist(_tp1, _tp2);

	res = 1;
L2: L1: 
L0:	return res;
} /* _tr42 */


void cv_convert_hist_scale P(( int _tp1, double _tp2, double _tp3));

#if MLPROTOTYPES
static int _tr43( MLINK mlp)
#else
static int _tr43(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	double _tp2;
	double _tp3;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetReal( mlp, &_tp2) ) goto L1;
	if ( ! MLGetReal( mlp, &_tp3) ) goto L2;
	if ( ! MLNewPacket(mlp) ) goto L3;

	cv_convert_hist_scale(_tp1, _tp2, _tp3);

	res = 1;
L3: L2: L1: 
L0:	return res;
} /* _tr43 */


void cv_get_hue_sat_hist_image P(( int _tp1, int _tp2));

#if MLPROTOTYPES
static int _tr44( MLINK mlp)
#else
static int _tr44(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int _tp2;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLNewPacket(mlp) ) goto L2;

	cv_get_hue_sat_hist_image(_tp1, _tp2);

	res = 1;
L2: L1: 
L0:	return res;
} /* _tr44 */


void cv_threshold P(( int _tp1, int _tp2, double _tp3, double _tp4, int _tp5));

#if MLPROTOTYPES
static int _tr45( MLINK mlp)
#else
static int _tr45(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int _tp2;
	double _tp3;
	double _tp4;
	int _tp5;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetReal( mlp, &_tp3) ) goto L2;
	if ( ! MLGetReal( mlp, &_tp4) ) goto L3;
	if ( ! MLGetInteger( mlp, &_tp5) ) goto L4;
	if ( ! MLNewPacket(mlp) ) goto L5;

	cv_threshold(_tp1, _tp2, _tp3, _tp4, _tp5);

	res = 1;
L5: L4: L3: L2: L1: 
L0:	return res;
} /* _tr45 */


void cv_canny P(( int _tp1, int _tp2, double _tp3, double _tp4, int _tp5));

#if MLPROTOTYPES
static int _tr46( MLINK mlp)
#else
static int _tr46(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int _tp2;
	double _tp3;
	double _tp4;
	int _tp5;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetReal( mlp, &_tp3) ) goto L2;
	if ( ! MLGetReal( mlp, &_tp4) ) goto L3;
	if ( ! MLGetInteger( mlp, &_tp5) ) goto L4;
	if ( ! MLNewPacket(mlp) ) goto L5;

	cv_canny(_tp1, _tp2, _tp3, _tp4, _tp5);

	res = 1;
L5: L4: L3: L2: L1: 
L0:	return res;
} /* _tr46 */


void cv_hough_lines2 P(( int _tp1, int _tp2, int _tp3, double _tp4, double _tp5, int _tp6, double _tp7, double _tp8));

#if MLPROTOTYPES
static int _tr47( MLINK mlp)
#else
static int _tr47(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int _tp2;
	int _tp3;
	double _tp4;
	double _tp5;
	int _tp6;
	double _tp7;
	double _tp8;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetInteger( mlp, &_tp3) ) goto L2;
	if ( ! MLGetReal( mlp, &_tp4) ) goto L3;
	if ( ! MLGetReal( mlp, &_tp5) ) goto L4;
	if ( ! MLGetInteger( mlp, &_tp6) ) goto L5;
	if ( ! MLGetReal( mlp, &_tp7) ) goto L6;
	if ( ! MLGetReal( mlp, &_tp8) ) goto L7;
	if ( ! MLNewPacket(mlp) ) goto L8;

	cv_hough_lines2(_tp1, _tp2, _tp3, _tp4, _tp5, _tp6, _tp7, _tp8);

	res = 1;
L8: L7: L6: L5: L4: L3: L2: L1: 
L0:	return res;
} /* _tr47 */


void cv_get_hough_lines P(( int _tp1, int _tp2));

#if MLPROTOTYPES
static int _tr48( MLINK mlp)
#else
static int _tr48(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int _tp2;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLNewPacket(mlp) ) goto L2;

	cv_get_hough_lines(_tp1, _tp2);

	res = 1;
L2: L1: 
L0:	return res;
} /* _tr48 */


void cv_draw_hough_lines P(( int _tp1, int _tp2, int _tp3, int * _tp4, long _tpl4, int _tp5, int _tp6));

#if MLPROTOTYPES
static int _tr49( MLINK mlp)
#else
static int _tr49(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int _tp2;
	int _tp3;
	int * _tp4;
	long _tpl4;
	int _tp5;
	int _tp6;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetInteger( mlp, &_tp3) ) goto L2;
	if ( ! MLGetIntegerList( mlp, &_tp4, &_tpl4) ) goto L3;
	if ( ! MLGetInteger( mlp, &_tp5) ) goto L4;
	if ( ! MLGetInteger( mlp, &_tp6) ) goto L5;
	if ( ! MLNewPacket(mlp) ) goto L6;

	cv_draw_hough_lines(_tp1, _tp2, _tp3, _tp4, _tpl4, _tp5, _tp6);

	res = 1;
L6: L5: L4:	MLDisownIntegerList( mlp, _tp4, _tpl4);
L3: L2: L1: 
L0:	return res;
} /* _tr49 */


void cv_find_contours P(( int _tp1, int _tp2, int _tp3, int _tp4, int * _tp5, long _tpl5));

#if MLPROTOTYPES
static int _tr50( MLINK mlp)
#else
static int _tr50(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int _tp2;
	int _tp3;
	int _tp4;
	int * _tp5;
	long _tpl5;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetInteger( mlp, &_tp3) ) goto L2;
	if ( ! MLGetInteger( mlp, &_tp4) ) goto L3;
	if ( ! MLGetIntegerList( mlp, &_tp5, &_tpl5) ) goto L4;
	if ( ! MLNewPacket(mlp) ) goto L5;

	cv_find_contours(_tp1, _tp2, _tp3, _tp4, _tp5, _tpl5);

	res = 1;
L5:	MLDisownIntegerList( mlp, _tp5, _tpl5);
L4: L3: L2: L1: 
L0:	return res;
} /* _tr50 */


void cv_get_contour P(( int _tp1));

#if MLPROTOTYPES
static int _tr51( MLINK mlp)
#else
static int _tr51(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLNewPacket(mlp) ) goto L1;

	cv_get_contour(_tp1);

	res = 1;
L1: 
L0:	return res;
} /* _tr51 */


void cv_fit_ellipse2 P(( int _tp1));

#if MLPROTOTYPES
static int _tr52( MLINK mlp)
#else
static int _tr52(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLNewPacket(mlp) ) goto L1;

	cv_fit_ellipse2(_tp1);

	res = 1;
L1: 
L0:	return res;
} /* _tr52 */


void cv_min_area_rect2 P(( int _tp1));

#if MLPROTOTYPES
static int _tr53( MLINK mlp)
#else
static int _tr53(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLNewPacket(mlp) ) goto L1;

	cv_min_area_rect2(_tp1);

	res = 1;
L1: 
L0:	return res;
} /* _tr53 */


void cv_contour_perimeter P(( int _tp1));

#if MLPROTOTYPES
static int _tr54( MLINK mlp)
#else
static int _tr54(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLNewPacket(mlp) ) goto L1;

	cv_contour_perimeter(_tp1);

	res = 1;
L1: 
L0:	return res;
} /* _tr54 */


int cv_load_image P(( const char * _tp1, int _tp2));

#if MLPROTOTYPES
static int _tr55( MLINK mlp)
#else
static int _tr55(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp0;
	const char * _tp1;
	int _tp2;
	if ( ! MLGetString( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLNewPacket(mlp) ) goto L2;

	_tp0 = cv_load_image(_tp1, _tp2);

	res = MLAbort ?
		MLPutFunction( mlp, "Abort", 0) : MLPutInteger( mlp, _tp0);
L2: L1:	MLDisownString(mlp, _tp1);

L0:	return res;
} /* _tr55 */


int cv_save_image P(( const char * _tp1, int _tp2));

#if MLPROTOTYPES
static int _tr56( MLINK mlp)
#else
static int _tr56(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp0;
	const char * _tp1;
	int _tp2;
	if ( ! MLGetString( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLNewPacket(mlp) ) goto L2;

	_tp0 = cv_save_image(_tp1, _tp2);

	res = MLAbort ?
		MLPutFunction( mlp, "Abort", 0) : MLPutInteger( mlp, _tp0);
L2: L1:	MLDisownString(mlp, _tp1);

L0:	return res;
} /* _tr56 */


int cv_capture_from_file P(( const char * _tp1));

#if MLPROTOTYPES
static int _tr57( MLINK mlp)
#else
static int _tr57(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp0;
	const char * _tp1;
	if ( ! MLGetString( mlp, &_tp1) ) goto L0;
	if ( ! MLNewPacket(mlp) ) goto L1;

	_tp0 = cv_capture_from_file(_tp1);

	res = MLAbort ?
		MLPutFunction( mlp, "Abort", 0) : MLPutInteger( mlp, _tp0);
L1:	MLDisownString(mlp, _tp1);

L0:	return res;
} /* _tr57 */


int cv_capture_from_cam P(( int _tp1));

#if MLPROTOTYPES
static int _tr58( MLINK mlp)
#else
static int _tr58(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp0;
	int _tp1;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLNewPacket(mlp) ) goto L1;

	_tp0 = cv_capture_from_cam(_tp1);

	res = MLAbort ?
		MLPutFunction( mlp, "Abort", 0) : MLPutInteger( mlp, _tp0);
L1: 
L0:	return res;
} /* _tr58 */


void cv_get_frame P(( int _tp1, int _tp2));

#if MLPROTOTYPES
static int _tr59( MLINK mlp)
#else
static int _tr59(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int _tp2;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLNewPacket(mlp) ) goto L2;

	cv_get_frame(_tp1, _tp2);

	res = 1;
L2: L1: 
L0:	return res;
} /* _tr59 */


void cv_create_video_writer P(( const char * _tp1, int _tp2, double _tp3, int _tp4, int _tp5, int _tp6));

#if MLPROTOTYPES
static int _tr60( MLINK mlp)
#else
static int _tr60(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	const char * _tp1;
	int _tp2;
	double _tp3;
	int _tp4;
	int _tp5;
	int _tp6;
	if ( ! MLGetString( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetReal( mlp, &_tp3) ) goto L2;
	if ( ! MLGetInteger( mlp, &_tp4) ) goto L3;
	if ( ! MLGetInteger( mlp, &_tp5) ) goto L4;
	if ( ! MLGetInteger( mlp, &_tp6) ) goto L5;
	if ( ! MLNewPacket(mlp) ) goto L6;

	cv_create_video_writer(_tp1, _tp2, _tp3, _tp4, _tp5, _tp6);

	res = 1;
L6: L5: L4: L3: L2: L1:	MLDisownString(mlp, _tp1);

L0:	return res;
} /* _tr60 */


void cv_release_video_writer P(( int _tp1));

#if MLPROTOTYPES
static int _tr61( MLINK mlp)
#else
static int _tr61(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLNewPacket(mlp) ) goto L1;

	cv_release_video_writer(_tp1);

	res = 1;
L1: 
L0:	return res;
} /* _tr61 */


void cv_write_frame P(( int _tp1, int _tp2));

#if MLPROTOTYPES
static int _tr62( MLINK mlp)
#else
static int _tr62(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int _tp2;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLNewPacket(mlp) ) goto L2;

	cv_write_frame(_tp1, _tp2);

	res = 1;
L2: L1: 
L0:	return res;
} /* _tr62 */


void cv_video_info P(( int _tp1));

#if MLPROTOTYPES
static int _tr63( MLINK mlp)
#else
static int _tr63(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLNewPacket(mlp) ) goto L1;

	cv_video_info(_tp1);

	res = 1;
L1: 
L0:	return res;
} /* _tr63 */


void cv_get_capture_property P(( int _tp1, int _tp2));

#if MLPROTOTYPES
static int _tr64( MLINK mlp)
#else
static int _tr64(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int _tp2;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLNewPacket(mlp) ) goto L2;

	cv_get_capture_property(_tp1, _tp2);

	res = 1;
L2: L1: 
L0:	return res;
} /* _tr64 */


void cv_codec_name P(( int _tp1));

#if MLPROTOTYPES
static int _tr65( MLINK mlp)
#else
static int _tr65(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLNewPacket(mlp) ) goto L1;

	cv_codec_name(_tp1);

	res = 1;
L1: 
L0:	return res;
} /* _tr65 */


void cv_fourcc P(( const char * _tp1));

#if MLPROTOTYPES
static int _tr66( MLINK mlp)
#else
static int _tr66(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	const char * _tp1;
	if ( ! MLGetString( mlp, &_tp1) ) goto L0;
	if ( ! MLNewPacket(mlp) ) goto L1;

	cv_fourcc(_tp1);

	res = 1;
L1:	MLDisownString(mlp, _tp1);

L0:	return res;
} /* _tr66 */


void cv_named_window P(( const char * _tp1, int _tp2));

#if MLPROTOTYPES
static int _tr67( MLINK mlp)
#else
static int _tr67(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	const char * _tp1;
	int _tp2;
	if ( ! MLGetString( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLNewPacket(mlp) ) goto L2;

	cv_named_window(_tp1, _tp2);

	res = 1;
L2: L1:	MLDisownString(mlp, _tp1);

L0:	return res;
} /* _tr67 */


void cv_show_image P(( const char * _tp1, int _tp2));

#if MLPROTOTYPES
static int _tr68( MLINK mlp)
#else
static int _tr68(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	const char * _tp1;
	int _tp2;
	if ( ! MLGetString( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLNewPacket(mlp) ) goto L2;

	cv_show_image(_tp1, _tp2);

	res = 1;
L2: L1:	MLDisownString(mlp, _tp1);

L0:	return res;
} /* _tr68 */


int show_image P(( const char * _tp1));

#if MLPROTOTYPES
static int _tr69( MLINK mlp)
#else
static int _tr69(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp0;
	const char * _tp1;
	if ( ! MLGetString( mlp, &_tp1) ) goto L0;
	if ( ! MLNewPacket(mlp) ) goto L1;

	_tp0 = show_image(_tp1);

	res = MLAbort ?
		MLPutFunction( mlp, "Abort", 0) : MLPutInteger( mlp, _tp0);
L1:	MLDisownString(mlp, _tp1);

L0:	return res;
} /* _tr69 */


void cv_play_video P(( const char * _tp1, int _tp2, int _tp3));

#if MLPROTOTYPES
static int _tr70( MLINK mlp)
#else
static int _tr70(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	const char * _tp1;
	int _tp2;
	int _tp3;
	if ( ! MLGetString( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetInteger( mlp, &_tp3) ) goto L2;
	if ( ! MLNewPacket(mlp) ) goto L3;

	cv_play_video(_tp1, _tp2, _tp3);

	res = 1;
L3: L2: L1:	MLDisownString(mlp, _tp1);

L0:	return res;
} /* _tr70 */


void cv_wait_mouse_event P(( const char * _tp1, int _tp2));

#if MLPROTOTYPES
static int _tr71( MLINK mlp)
#else
static int _tr71(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	const char * _tp1;
	int _tp2;
	if ( ! MLGetString( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLNewPacket(mlp) ) goto L2;

	cv_wait_mouse_event(_tp1, _tp2);

	res = 1;
L2: L1:	MLDisownString(mlp, _tp1);

L0:	return res;
} /* _tr71 */


void cv_get_selected_points P(( const char * _tp1, int _tp2, int * _tp3, long _tpl3));

#if MLPROTOTYPES
static int _tr72( MLINK mlp)
#else
static int _tr72(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	const char * _tp1;
	int _tp2;
	int * _tp3;
	long _tpl3;
	if ( ! MLGetString( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetIntegerList( mlp, &_tp3, &_tpl3) ) goto L2;
	if ( ! MLNewPacket(mlp) ) goto L3;

	cv_get_selected_points(_tp1, _tp2, _tp3, _tpl3);

	res = 1;
L3:	MLDisownIntegerList( mlp, _tp3, _tpl3);
L2: L1:	MLDisownString(mlp, _tp1);

L0:	return res;
} /* _tr72 */


static struct func {
	int   f_nargs;
	int   manual;
	int   (*f_func)P((MLINK));
	const char  *f_name;
	} _tramps[73] = {
		{ 0, 0, _tr0, "cv_open" },
		{ 0, 0, _tr1, "cv_close" },
		{ 3, 0, _tr2, "cv_create_image" },
		{ 1, 0, _tr3, "cv_release_image" },
		{ 1, 0, _tr4, "cv_image_info" },
		{ 1, 0, _tr5, "cv_create_mem_storage" },
		{ 1, 0, _tr6, "cv_get_seq_hnext" },
		{ 1, 0, _tr7, "cv_get_seq_hprev" },
		{ 1, 0, _tr8, "cv_get_seq_vnext" },
		{ 1, 0, _tr9, "cv_get_seq_vprev" },
		{ 1, 0, _tr10, "cv_get_seq_size" },
		{ 4, 0, _tr11, "cv_create_mat" },
		{ 4, 0, _tr12, "cv_create_mat_header" },
		{ 1, 0, _tr13, "cv_get_size" },
		{ 3, 0, _tr14, "cv_get_row" },
		{ 3, 0, _tr15, "cv_get_col" },
		{ 3, 0, _tr16, "cv_get_sub_rect" },
		{ 1, 0, _tr17, "cv_min_max_loc" },
		{ 4, 0, _tr18, "cv_convert_scale" },
		{ 3, 0, _tr19, "cv_copy" },
		{ 3, 0, _tr20, "cv_get_image_array" },
		{ 1, 0, _tr21, "cv_get_int_image_array" },
		{ 2, 0, _tr22, "cv_get_int_frame_array" },
		{ 2, 0, _tr23, "cv_get_array" },
		{ 2, 2, _tr24, "cv_set_array" },
		{ 2, 0, _tr25, "cv_set_image_roi" },
		{ 1, 0, _tr26, "cv_reset_image_roi" },
		{ 5, 0, _tr27, "cv_split" },
		{ 2, 0, _tr28, "cv_xy_mean" },
		{ 3, 0, _tr29, "cv_filter_2d" },
		{ 3, 0, _tr30, "cv_laplace" },
		{ 5, 0, _tr31, "cv_sobel" },
		{ 6, 0, _tr32, "cv_smooth" },
		{ 3, 0, _tr33, "cv_cvt_color" },
		{ 8, 0, _tr34, "cv_draw_contours" },
		{ 4, 0, _tr35, "cv_rectangle" },
		{ 2, 2, _tr36, "cv_create_hist" },
		{ 3, 0, _tr37, "cv_calc_back_project" },
		{ 4, 0, _tr38, "cv_calc_hist" },
		{ 1, 0, _tr39, "cv_get_hist_array" },
		{ 1, 0, _tr40, "cv_get_minmax_hist_value" },
		{ 2, 0, _tr41, "cv_normalize_hist" },
		{ 2, 0, _tr42, "cv_thresh_hist" },
		{ 3, 0, _tr43, "cv_convert_hist_scale" },
		{ 2, 0, _tr44, "cv_get_hue_sat_hist_image" },
		{ 5, 0, _tr45, "cv_threshold" },
		{ 5, 0, _tr46, "cv_canny" },
		{ 8, 0, _tr47, "cv_hough_lines2" },
		{ 2, 0, _tr48, "cv_get_hough_lines" },
		{ 6, 0, _tr49, "cv_draw_hough_lines" },
		{ 5, 0, _tr50, "cv_find_contours" },
		{ 1, 0, _tr51, "cv_get_contour" },
		{ 1, 0, _tr52, "cv_fit_ellipse2" },
		{ 1, 0, _tr53, "cv_min_area_rect2" },
		{ 1, 0, _tr54, "cv_contour_perimeter" },
		{ 2, 0, _tr55, "cv_load_image" },
		{ 2, 0, _tr56, "cv_save_image" },
		{ 1, 0, _tr57, "cv_capture_from_file" },
		{ 1, 0, _tr58, "cv_capture_from_cam" },
		{ 2, 0, _tr59, "cv_get_frame" },
		{ 6, 0, _tr60, "cv_create_video_writer" },
		{ 1, 0, _tr61, "cv_release_video_writer" },
		{ 2, 0, _tr62, "cv_write_frame" },
		{ 1, 0, _tr63, "cv_video_info" },
		{ 2, 0, _tr64, "cv_get_capture_property" },
		{ 1, 0, _tr65, "cv_codec_name" },
		{ 1, 0, _tr66, "cv_fourcc" },
		{ 2, 0, _tr67, "cv_named_window" },
		{ 2, 0, _tr68, "cv_show_image" },
		{ 1, 0, _tr69, "show_image" },
		{ 3, 0, _tr70, "cv_play_video" },
		{ 2, 0, _tr71, "cv_wait_mouse_event" },
		{ 3, 0, _tr72, "cv_get_selected_points" }
		};

static const char* evalstrs[] = {
	"CVLoadImageUnchanged=-1; CVLoadImageGrayScale = 0; CVLoadImageCo",
	"lor=1;",
	(const char*)0,
	"CVWindowAutosize=1;",
	(const char*)0,
	"CVEventMouseMove=0; CVEventLButtonDown = 1; CVEventRButtonDown =",
	" 2;",
	(const char*)0,
	"CV8U=0; CV8S=1; CV16U=2; CV16S=3; CV32S=4; CV32F=5; CV64F=6;",
	(const char*)0,
	"IplDepth1U = 1; IplDepth8U = 8; IplDepth16U = 16; IplDepth32F=32",
	"; IplDepth8S = FromDigits[\"80000008\",16]-FromDigits[\"FFFFFFFF\",1",
	"6]-1; IplDepth16S = FromDigits[\"80000010\",16]-FromDigits[\"FFFFFF",
	"FF\",16]-1; IplDepth32S = FromDigits[\"80000020\",16]-FromDigits[\"F",
	"FFFFFFF\",16]-1;",
	(const char*)0,
	"CVBGR2BGRA=0;  CVRGB2RGBA=CVBGR2BGRA; CVBGRA2BGR=1; CVRGBA2RGB=C",
	"VBGRA2BGR;CVBGR2RGBA=2;CVRGB2BGRA=CVBGR2RGBA;CVRGBA2BGR=3;CVBGRA",
	"2RGB=CVRGBA2BGR;CVBGR2RGB=4;CVRGB2BGR=CVBGR2RGB;CVBGRA2RGBA=5;CV",
	"RGBA2BGRA=CVBGRA2RGBA;CVBGR2GRAY=6;CVRGB2GRAY=7;CVGRAY2BGR=8;CVG",
	"RAY2RGB=CVGRAY2BGR;CVGRAY2BGRA=9;CVGRAY2RGBA=CVGRAY2BGRA;CVBGRA2",
	"GRAY=10;CVRGBA2GRAY=11;CVBGR2BGR565=12;CVRGB2BGR565=13;CVBGR5652",
	"BGR=14;CVBGR5652RGB=15;CVBGRA2BGR565=16;CVRGBA2BGR565=17;CVBGR56",
	"52BGRA=18;CVBGR5652RGBA=19;CVGRAY2BGR565=20;CVBGR5652GRAY=21;CVB",
	"GR2BGR555=22;CVRGB2BGR555=23;CVBGR5552BGR=24;CVBGR5552RGB=25;CVB",
	"GRA2BGR555=26;CVRGBA2BGR555=27;CVBGR5552BGRA=28;CVBGR5552RGBA=29",
	";CVGRAY2BGR555=30;CVBGR5552GRAY=31;CVBGR2XYZ=32;CVRGB2XYZ=33;CVX",
	"YZ2BGR=34;CVXYZ2RGB=35;CVBGR2YCrCb=36;CVRGB2YCrCb=37;CVYCrCb2BGR",
	"=38;CVYCrCb2RGB=39;CVBGR2HSV=40;CVRGB2HSV=41;CVBGR2Lab=44;CVRGB2",
	"Lab=45;CVBayerBG2BGR=46;CVBayerGB2BGR=47;CVBayerRG2BGR=48;CVBaye",
	"rGR2BGR=49;CVBayerBG2RGB=CVBayerRG2BGR;CVBayerGB2RGB=CVBayerGR2B",
	"GR;CVBayerRG2RGB=CVBayerBG2BGR;CVBayerGR2RGB=CVBayerGB2BGR;CVBGR",
	"2Luv=50;CVRGB2Luv=51;CVBGR2HLS=52;CVRGB2HLS=53;CVHSV2BGR=54;CVHS",
	"V2RGB=55;CVLab2BGR=56;CVLab2RGB=57;CVLuv2BGR=58;CVLuv2RGB=59;CVH",
	"LS2BGR=60;CVHLS2RGB=61;CVCOLORCVTMAX=100;",
	(const char*)0,
	"CVHistArray=0; CVHistSparse=1;CVHistUniform=1;",
	(const char*)0,
	"CVThreshBinary=0;CVThreshBinaryInv=1;CVThreshTrunc=2;CVThreshToZ",
	"ero=3;CVThreshToZeroInv=4;CVThreshMask=7;CVThreshOTSU=8;",
	(const char*)0,
	"CVRetrExternal=0; CVRetrList=1; CVRetrCcomp=2; CVRetrTree=3;",
	(const char*)0,
	"CVChainCode=0; CVChainApproxNone=1; CVChainApproxSimple=2; CVCha",
	"inApproxTC89L1=3; CVChainApproxTC89KCOS=4; CVLinkRuns=5;",
	(const char*)0,
	"CVCapPropPosMsec=0; CVCapPropPosFrames=1; CVCapPropPosAviRatio=2",
	"; CVCapPropFrameWidth=3; CVCapPropFrameHeight = 4; CVCapPropFps=",
	"5; CVCapPropFourcc=6; CVCapPropFrameCount=7; CVCapPropFormat=8; ",
	"CVCapPropMode = 9; CVCapPropBrightness = 10; CVCapPropContrast=1",
	"1; CVCapPropSaturation=12; CVCapPropHue=13; CVCapPropGain = 14; ",
	"CVCapPropExposure=15; CVCapPropConvertRGB = 16; CVCapPropWhiteBa",
	"lnace = 17; CVCapPropRectification = 18;",
	(const char*)0,
	"CVHoughStandard=0; CVHoughProbabilistic=1; CVHoughMultiScale=2; ",
	"CVHoughGradient=3;",
	(const char*)0,
	"CVBlurNoScale=0; CVBlur=1; CVGaussian=2; CVMedian=3; CVBilateral",
	"=4;",
	(const char*)0,
	(const char*)0
};
#define CARDOF_EVALSTRS 13

static int _definepattern P(( MLINK, char*, char*, int));

static int _doevalstr P(( MLINK, int));

int  _MLDoCallPacket P(( MLINK, struct func[], int));


#if MLPROTOTYPES
int MLInstall( MLINK mlp)
#else
int MLInstall(mlp) MLINK mlp;
#endif
{
	int _res;
	_res = MLConnect(mlp);
	if (_res) _res = _doevalstr( mlp, 0);
	if (_res) _res = _doevalstr( mlp, 1);
	if (_res) _res = _doevalstr( mlp, 2);
	if (_res) _res = _doevalstr( mlp, 3);
	if (_res) _res = _doevalstr( mlp, 4);
	if (_res) _res = _doevalstr( mlp, 5);
	if (_res) _res = _doevalstr( mlp, 6);
	if (_res) _res = _doevalstr( mlp, 7);
	if (_res) _res = _doevalstr( mlp, 8);
	if (_res) _res = _doevalstr( mlp, 9);
	if (_res) _res = _doevalstr( mlp, 10);
	if (_res) _res = _doevalstr( mlp, 11);
	if (_res) _res = _doevalstr( mlp, 12);
	if (_res) _res = _definepattern(mlp, (char *)"iCVOpen[]", (char *)"{}", 0);
	if (_res) _res = _definepattern(mlp, (char *)"iCVClose[]", (char *)"{}", 1);
	if (_res) _res = _definepattern(mlp, (char *)"CVCreateImage[size_List,depth_Integer,channels_Integer]", (char *)"{size,depth,channels}", 2);
	if (_res) _res = _definepattern(mlp, (char *)"CVReleaseImage[ref_Integer]", (char *)"{ref}", 3);
	if (_res) _res = _definepattern(mlp, (char *)"CVImageInfo[ref_Integer]", (char *)"{ref}", 4);
	if (_res) _res = _definepattern(mlp, (char *)"CVCreateMemStorage[blocksize_Integer]", (char *)"{blocksize}", 5);
	if (_res) _res = _definepattern(mlp, (char *)"CVGetSeqHNext[refseq_Integer]", (char *)"{refseq}", 6);
	if (_res) _res = _definepattern(mlp, (char *)"CVGetSeqHPrev[refseq_Integer]", (char *)"{refseq}", 7);
	if (_res) _res = _definepattern(mlp, (char *)"CVGetSeqVNext[refseq_Integer]", (char *)"{refseq}", 8);
	if (_res) _res = _definepattern(mlp, (char *)"CVGetSeqVPrev[refseq_Integer]", (char *)"{refseq}", 9);
	if (_res) _res = _definepattern(mlp, (char *)"CVGetSeqSize[seqRef_Integer]", (char *)"{seqRef}", 10);
	if (_res) _res = _definepattern(mlp, (char *)"CVCreateMat[rows_Integer,cols_Integer,depthtype_Integer,channels_Integer]", (char *)"{rows,cols,depthtype,channels}", 11);
	if (_res) _res = _definepattern(mlp, (char *)"CVCreateMatHeader[rows_Integer,cols_Integer,depthtype_Integer,channels_Integer]", (char *)"{rows,cols,depthtype,channels}", 12);
	if (_res) _res = _definepattern(mlp, (char *)"CVGetSize[ref_Integer]", (char *)"{ref}", 13);
	if (_res) _res = _definepattern(mlp, (char *)"CVGetRow[refA_Integer,refB_Integer,row_Integer]", (char *)"{refA,refB,row}", 14);
	if (_res) _res = _definepattern(mlp, (char *)"CVGetCol[refA_Integer,refB_Integer,col_Integer]", (char *)"{refA,refB,col}", 15);
	if (_res) _res = _definepattern(mlp, (char *)"CVGetSubRect[arrref_Integer,submatref_Integer,rect_List]", (char *)"{arrref,submatref,rect}", 16);
	if (_res) _res = _definepattern(mlp, (char *)"CVMinMaxLoc[arrref_Integer]", (char *)"{arrref}", 17);
	if (_res) _res = _definepattern(mlp, (char *)"CVConvertScale[srcref_Integer,dstref_Integer,scale_Real,shift_Real]", (char *)"{srcref,dstref,scale,shift}", 18);
	if (_res) _res = _definepattern(mlp, (char *)"CVCopy[srcref_Integer,dstref_Integer,maskref_Integer]", (char *)"{srcref,dstref,maskref}", 19);
	if (_res) _res = _definepattern(mlp, (char *)"CVGetImageArray[refimg_Integer,norm_Integer, order_Integer]", (char *)"{refimg,norm,order}", 20);
	if (_res) _res = _definepattern(mlp, (char *)"CVGetIntImageArray[refimg_Integer]", (char *)"{refimg}", 21);
	if (_res) _res = _definepattern(mlp, (char *)"CVGetIntFrameArray[refcapt_Integer,skip_Integer]", (char *)"{refcapt,skip}", 22);
	if (_res) _res = _definepattern(mlp, (char *)"CVGetArray[ref_Integer,channel_Integer]", (char *)"{ref,channel}", 23);
	if (_res) _res = _definepattern(mlp, (char *)"CVSetArray[ref_Integer,channel_Integer,array_List]", (char *)"{ref,channel,array}", 24);
	if (_res) _res = _definepattern(mlp, (char *)"CVSetImageROI[imgref_Integer,rect_List]", (char *)"{imgref,rect}", 25);
	if (_res) _res = _definepattern(mlp, (char *)"CVResetImageROI[imgref_Integer]", (char *)"{imgref}", 26);
	if (_res) _res = _definepattern(mlp, (char *)"CVSplit[refsrc_Integer,refdst0_Integer,refdst1_Integer,refdst2_Integer,refdst3_Integer]", (char *)"{refsrc,refdst0,refdst1,refdst2,refdst3}", 27);
	if (_res) _res = _definepattern(mlp, (char *)"CVXYMean[imgref_Integer,rect_List]", (char *)"{imgref,rect}", 28);
	if (_res) _res = _definepattern(mlp, (char *)"CVFilter2D[srcref_Integer,dstref_Integer,kernel_Integer]", (char *)"{srcref,dstref,kernel}", 29);
	if (_res) _res = _definepattern(mlp, (char *)"CVLaplace[srcref_Integer,dstref_Integer,aperture_Integer]", (char *)"{srcref,dstref,aperture}", 30);
	if (_res) _res = _definepattern(mlp, (char *)"CVSobel[srcref_Integer,dstref_Integer,xorder_Integer,yorder_Integer,aperture_Integer]", (char *)"{srcref,dstref,xorder,yorder,aperture}", 31);
	if (_res) _res = _definepattern(mlp, (char *)"CVSmooth[srcref_Integer,dstref_Integer,smoothtype_Integer,param1_Integer,param2_Integer,param3_Real]", (char *)"{srcref,dstref,smoothtype,param1,param2,param3}", 32);
	if (_res) _res = _definepattern(mlp, (char *)"CVCvtColor[refsrc_Integer,refdst_Integer,code_Integer]", (char *)"{refsrc,refdst,code}", 33);
	if (_res) _res = _definepattern(mlp, (char *)"CVDrawContours[refimg_Integer,refcontours_Integer,extColor_List,holeColor_List,maxLevel_Integer, thickness_Integer, lineType_Integer, offset_List]", (char *)"{refimg,refcontours,extColor,holeColor,maxLevel,thickness,lineType,offset}", 34);
	if (_res) _res = _definepattern(mlp, (char *)"CVRectangle[imgref_Integer,rect_List,color_List,thickness_Integer]", (char *)"{imgref,rect,color,thickness}", 35);
	if (_res) _res = _definepattern(mlp, (char *)"CVCreateHist[sizes_List,type_Integer,ranges_List,uniform_Integer]", (char *)"{sizes,type,ranges,uniform}", 36);
	if (_res) _res = _definepattern(mlp, (char *)"CVCalcBackProject[images_List,backproject_Integer,hist_Integer]", (char *)"{images,backproject,hist}", 37);
	if (_res) _res = _definepattern(mlp, (char *)"CVCalcHist[images_List,hist_Integer,accumulate_Integer,mask_Integer]", (char *)"{images,hist,accumulate,mask}", 38);
	if (_res) _res = _definepattern(mlp, (char *)"CVGetHistArray[hist_Integer]", (char *)"{hist}", 39);
	if (_res) _res = _definepattern(mlp, (char *)"CVGetMinMaxHistValue[hist_Integer]", (char *)"{hist}", 40);
	if (_res) _res = _definepattern(mlp, (char *)"CVNormalizeHist[hist_Integer,factor_Real]", (char *)"{hist,factor}", 41);
	if (_res) _res = _definepattern(mlp, (char *)"CVThreshHist[hist_Integer,threshold_Real]", (char *)"{hist,threshold}", 42);
	if (_res) _res = _definepattern(mlp, (char *)"CVConvertHistScale[histref_Integer,scale_Real,shift_Real]", (char *)"{histref,scale,shift}", 43);
	if (_res) _res = _definepattern(mlp, (char *)"CVGetHueSatHistImage[histref_Integer,size_Integer]", (char *)"{histref,size}", 44);
	if (_res) _res = _definepattern(mlp, (char *)"CVThreshold[refsrc_Integer,refdst_Integer,threshold_Real,maxvalue_Real,type_Integer]", (char *)"{refsrc,refdst,threshold,maxvalue,type}", 45);
	if (_res) _res = _definepattern(mlp, (char *)"CVCanny[imgref_Integer,edgesref_Integer,threshold1_Real,threshold2_Real,aperture_Integer]", (char *)"{imgref,edgesref,threshold1,threshold2,aperture}", 46);
	if (_res) _res = _definepattern(mlp, (char *)"CVHoughLines2[imgref_Integer,memref_Integer,method_Integer,rho_Real,theta_Real,threshold_Integer,param1_Real,param2_Real]", (char *)"{imgref,memref,method,rho,theta,threshold,param1,param2}", 47);
	if (_res) _res = _definepattern(mlp, (char *)"CVGetHoughLines[seqref_Integer,method_Integer]", (char *)"{seqref,method}", 48);
	if (_res) _res = _definepattern(mlp, (char *)"CVDrawHoughLines[imgref_Integer,seqref_Integer,method_Integer,rgb_List,length_Integer,thickness_Integer]", (char *)"{imgref,seqref,method,rgb,length,thickness}", 49);
	if (_res) _res = _definepattern(mlp, (char *)"CVFindContours[refimg_Integer,refmem_Integer,mode_Integer,method_Integer,offset_List]", (char *)"{refimg,refmem,mode,method,offset}", 50);
	if (_res) _res = _definepattern(mlp, (char *)"CVGetContour[refseq_Integer]", (char *)"{refseq}", 51);
	if (_res) _res = _definepattern(mlp, (char *)"CVFitEllipse2[refarr_Integer]", (char *)"{refarr}", 52);
	if (_res) _res = _definepattern(mlp, (char *)"CVMinAreaRect2[refarr_Integer]", (char *)"{refarr}", 53);
	if (_res) _res = _definepattern(mlp, (char *)"CVContourPerimeter[refseq_Integer]", (char *)"{refseq}", 54);
	if (_res) _res = _definepattern(mlp, (char *)"iCVLoadImage[filename_String,iscolor_Integer]", (char *)"{ filename, iscolor}", 55);
	if (_res) _res = _definepattern(mlp, (char *)"CVSaveImage[filename_String,imgref_Integer]", (char *)"{ filename, imgref}", 56);
	if (_res) _res = _definepattern(mlp, (char *)"iCVCaptureFromFile[filename_String]", (char *)"{filename}", 57);
	if (_res) _res = _definepattern(mlp, (char *)"CVCaptureFromCAM[index_Integer]", (char *)"{index}", 58);
	if (_res) _res = _definepattern(mlp, (char *)"CVGetFrame[ref_Integer,skip_Integer]", (char *)"{ref,skip}", 59);
	if (_res) _res = _definepattern(mlp, (char *)"CVCreateVideoWriter[filename_String,fourcc_Integer,fps_Real,width_Integer,height_Integer,iscolor_Integer]", (char *)"{filename,fourcc,fps,width,height,iscolor}", 60);
	if (_res) _res = _definepattern(mlp, (char *)"CVReleaseVideoWriter[writref_Integer]", (char *)"{writref}", 61);
	if (_res) _res = _definepattern(mlp, (char *)"CVWriteFrame[writerRef_Integer,imgRef_Integer]", (char *)"{writerRef,imgRef}", 62);
	if (_res) _res = _definepattern(mlp, (char *)"CVVideoInfo[ref_Integer]", (char *)"{ref}", 63);
	if (_res) _res = _definepattern(mlp, (char *)"CVGetCaptureProperty[captref_Integer,property_Integer]", (char *)"{captref,property}", 64);
	if (_res) _res = _definepattern(mlp, (char *)"CVCodecName[fourcc_Integer]", (char *)"{fourcc}", 65);
	if (_res) _res = _definepattern(mlp, (char *)"CVFourcc[name_String]", (char *)"{name}", 66);
	if (_res) _res = _definepattern(mlp, (char *)"CVNamedWindow[name_String,flags_Integer]", (char *)"{name,flags}", 67);
	if (_res) _res = _definepattern(mlp, (char *)"CVShowImage[name_String,ref_Integer]", (char *)"{name,ref}", 68);
	if (_res) _res = _definepattern(mlp, (char *)"ShowImage[filename_String]", (char *)"{filename}", 69);
	if (_res) _res = _definepattern(mlp, (char *)"CVPlayVideo[window_String,ref_Integer,delay_Integer]", (char *)"{window,ref,delay}", 70);
	if (_res) _res = _definepattern(mlp, (char *)"CVWaitMouseEvent[name_String,type_Integer]", (char *)"{name,type}", 71);
	if (_res) _res = _definepattern(mlp, (char *)"CVGetSelectedPoints[window_String,imgref_Integer,color_List]", (char *)"{window,imgref,color}", 72);
	if (_res) _res = MLPutSymbol( mlp, "End");
	if (_res) _res = MLFlush( mlp);
	return _res;
} /* MLInstall */


#if MLPROTOTYPES
int MLDoCallPacket( MLINK mlp)
#else
int MLDoCallPacket( mlp) MLINK mlp;
#endif
{
	return _MLDoCallPacket( mlp, _tramps, 73);
} /* MLDoCallPacket */

/******************************* begin trailer ********************************/

#ifndef EVALSTRS_AS_BYTESTRINGS
#	define EVALSTRS_AS_BYTESTRINGS 1
#endif


#if CARDOF_EVALSTRS
#if MLPROTOTYPES
static int  _doevalstr( MLINK mlp, int n)
#else
static int  _doevalstr( mlp, n)
	 MLINK mlp; int n;
#endif
{
	long bytesleft, charsleft, bytesnow;
#if !EVALSTRS_AS_BYTESTRINGS
	long charsnow;
#endif
	char **s, **p;
	char *t;

	s = (char **)evalstrs;
	while( n-- > 0){
		if( *s == 0) break;
		while( *s++ != 0){}
	}
	if( *s == 0) return 0;
	bytesleft = 0;
	charsleft = 0;
	p = s;
	while( *p){
		t = *p; while( *t) ++t;
		bytesnow = t - *p;
		bytesleft += bytesnow;
		charsleft += bytesnow;
#if !EVALSTRS_AS_BYTESTRINGS
		t = *p;
		charsleft -= MLCharacterOffset( &t, t + bytesnow, bytesnow);
		/* assert( t == *p + bytesnow); */
#endif
		++p;
	}


	MLPutNext( mlp, MLTKSTR);
#if EVALSTRS_AS_BYTESTRINGS
	p = s;
	while( *p){
		t = *p; while( *t) ++t;
		bytesnow = t - *p;
		bytesleft -= bytesnow;
		MLPut8BitCharacters( mlp, bytesleft, (unsigned char*)*p, bytesnow);
		++p;
	}
#else
	MLPut7BitCount( mlp, charsleft, bytesleft);
	p = s;
	while( *p){
		t = *p; while( *t) ++t;
		bytesnow = t - *p;
		bytesleft -= bytesnow;
		t = *p;
		charsnow = bytesnow - MLCharacterOffset( &t, t + bytesnow, bytesnow);
		/* assert( t == *p + bytesnow); */
		charsleft -= charsnow;
		MLPut7BitCharacters(  mlp, charsleft, *p, bytesnow, charsnow);
		++p;
	}
#endif
	return MLError( mlp) == MLEOK;
}
#endif /* CARDOF_EVALSTRS */


#if MLPROTOTYPES
static int  _definepattern( MLINK mlp, char *patt, char *args, int func_n)
#else
static int  _definepattern( mlp, patt, args, func_n)
	MLINK  mlp;
	char  *patt, *args;
	int    func_n;
#endif
{
	MLPutFunction( mlp, "DefineExternal", (long)3);
	  MLPutString( mlp, patt);
	  MLPutString( mlp, args);
	  MLPutInteger( mlp, func_n);
	return !MLError(mlp);
} /* _definepattern */


#if MLPROTOTYPES
int _MLDoCallPacket( MLINK mlp, struct func functable[], int nfuncs)
#else
int _MLDoCallPacket( mlp, functable, nfuncs)
	MLINK mlp;
	struct func functable[];
	int nfuncs;
#endif
{
	long len;
	int n, res = 0;
	struct func* funcp;

	if( ! MLGetInteger( mlp, &n) ||  n < 0 ||  n >= nfuncs) goto L0;
	funcp = &functable[n];

	if( funcp->f_nargs >= 0
	&& ( ! MLCheckFunction(mlp, "List", &len)
	     || ( !funcp->manual && (len != funcp->f_nargs))
	     || (  funcp->manual && (len <  funcp->f_nargs))
	   )
	) goto L0;

	stdlink = mlp;
	res = (*funcp->f_func)( mlp);

L0:	if( res == 0)
		res = MLClearError( mlp) && MLPutSymbol( mlp, "$Failed");
	return res && MLEndPacket( mlp) && MLNewPacket( mlp);
} /* _MLDoCallPacket */


#if MLPROTOTYPES
mlapi_packet MLAnswer( MLINK mlp)
#else
mlapi_packet MLAnswer( mlp)
	MLINK mlp;
#endif
{
	mlapi_packet pkt = 0;

	while( !MLDone && !MLError(mlp) && (pkt = MLNextPacket(mlp), pkt) && pkt == CALLPKT){
		MLAbort = 0;
		if( !MLDoCallPacket(mlp)) pkt = 0;
	}
	MLAbort = 0;
	return pkt;
} /* MLAnswer */



/*
	Module[ { me = $ParentLink},
		$ParentLink = contents of RESUMEPKT;
		Message[ MessageName[$ParentLink, "notfe"], me];
		me]
*/

#if MLPROTOTYPES
static int refuse_to_be_a_frontend( MLINK mlp)
#else
static int refuse_to_be_a_frontend( mlp)
	MLINK mlp;
#endif
{
	int pkt;

	MLPutFunction( mlp, "EvaluatePacket", 1);
	  MLPutFunction( mlp, "Module", 2);
	    MLPutFunction( mlp, "List", 1);
		  MLPutFunction( mlp, "Set", 2);
		    MLPutSymbol( mlp, "me");
	        MLPutSymbol( mlp, "$ParentLink");
	  MLPutFunction( mlp, "CompoundExpression", 3);
	    MLPutFunction( mlp, "Set", 2);
	      MLPutSymbol( mlp, "$ParentLink");
	      MLTransferExpression( mlp, mlp);
	    MLPutFunction( mlp, "Message", 2);
	      MLPutFunction( mlp, "MessageName", 2);
	        MLPutSymbol( mlp, "$ParentLink");
	        MLPutString( mlp, "notfe");
	      MLPutSymbol( mlp, "me");
	    MLPutSymbol( mlp, "me");
	MLEndPacket( mlp);

	while( (pkt = MLNextPacket( mlp), pkt) && pkt != SUSPENDPKT)
		MLNewPacket( mlp);
	MLNewPacket( mlp);
	return MLError( mlp) == MLEOK;
}


#if MLPROTOTYPES
#if MLINTERFACE >= 3
int MLEvaluate( MLINK mlp, char *s)
#else
int MLEvaluate( MLINK mlp, charp_ct s)
#endif /* MLINTERFACE >= 3 */
#else
int MLEvaluate( mlp, s)
	MLINK mlp;
#if MLINTERFACE >= 3
	char *s;
#else
	charp_ct s;
#endif /* MLINTERFACE >= 3 */
#endif
{
	if( MLAbort) return 0;
	return MLPutFunction( mlp, "EvaluatePacket", 1L)
		&& MLPutFunction( mlp, "ToExpression", 1L)
		&& MLPutString( mlp, s)
		&& MLEndPacket( mlp);
} /* MLEvaluate */


#if MLPROTOTYPES
#if MLINTERFACE >= 3
int MLEvaluateString( MLINK mlp, char *s)
#else
int MLEvaluateString( MLINK mlp, charp_ct s)
#endif /* MLINTERFACE >= 3 */
#else
int MLEvaluateString( mlp, s)
	MLINK mlp;
#if MLINTERFACE >= 3
	char *s;
#else
	charp_ct s;
#endif /* MLINTERFACE >= 3 */
#endif
{
	int pkt;
	if( MLAbort) return 0;
	if( MLEvaluate( mlp, s)){
		while( (pkt = MLAnswer( mlp), pkt) && pkt != RETURNPKT)
			MLNewPacket( mlp);
		MLNewPacket( mlp);
	}
	return MLError( mlp) == MLEOK;
} /* MLEvaluateString */


#if MLINTERFACE >= 3
#if MLPROTOTYPES
void MLDefaultHandler( MLINK mlp, int message, int n)
#else
void MLDefaultHandler( mlp, message, n)
	MLINK mlp;
	int message, n;
#endif
#else
#if MLPROTOTYPES
void MLDefaultHandler( MLINK mlp, unsigned long message, unsigned long n)
#else
void MLDefaultHandler( mlp, message, n)
	MLINK mlp;
	unsigned long message, n;
#endif
#endif /* MLINTERFACE >= 3 */
{
	switch (message){
	case MLTerminateMessage:
		MLDone = 1;
	case MLInterruptMessage:
	case MLAbortMessage:
		MLAbort = 1;
	default:
		return;
	}
}

#if MLPROTOTYPES
#if MLINTERFACE >= 3
static int _MLMain( char **argv, char **argv_end, char *commandline)
#else
static int _MLMain( charpp_ct argv, charpp_ct argv_end, charp_ct commandline)
#endif /* MLINTERFACE >= 3 */
#else
static int _MLMain( argv, argv_end, commandline)
#if MLINTERFACE >= 3
  char **argv, argv_end;
  char *commandline;
#else
  charpp_ct argv, argv_end;
  charp_ct commandline;
#endif /* MLINTERFACE >= 3 */
#endif
{
	MLINK mlp;
#if MLINTERFACE >= 3
	int err;
#else
	long err;
#endif /* MLINTERFACE >= 3 */

	if( !stdenv)
		stdenv = MLInitialize( (MLParametersPointer)0);
	if( stdenv == (MLEnvironment)0) goto R0;

#if MLINTERFACE >= 3
	if( !stdhandler)
		stdhandler = (MLMessageHandlerObject)MLDefaultHandler;
#else
	if( !stdhandler)
		stdhandler = MLCreateMessageHandler( stdenv, MLDefaultHandler, 0);
#endif /* MLINTERFACE >= 3 */


	mlp = commandline
		? MLOpenString( stdenv, commandline, &err)
#if MLINTERFACE >= 3
		: MLOpenArgcArgv( stdenv, (int)(argv_end - argv), argv, &err);
#else
		: MLOpenArgv( stdenv, argv, argv_end, &err);
#endif
	if( mlp == (MLINK)0){
		MLAlert( stdenv, MLErrorString( stdenv, err));
		goto R1;
	}

	if( stdyielder) MLSetYieldFunction( mlp, stdyielder);
	if( stdhandler) MLSetMessageHandler( mlp, stdhandler);

	if( MLInstall( mlp))
		while( MLAnswer( mlp) == RESUMEPKT){
			if( ! refuse_to_be_a_frontend( mlp)) break;
		}

	MLClose( mlp);
R1:	MLDeinitialize( stdenv);
	stdenv = (MLEnvironment)0;
R0:	return !MLDone;
} /* _MLMain */


#if MLPROTOTYPES
#if MLINTERFACE >= 3
int MLMainString( char *commandline)
#else
int MLMainString( charp_ct commandline)
#endif /* MLINTERFACE >= 3 */
#else
#if MLINTERFACE >= 3
int MLMainString( commandline)  char *commandline;
#else
int MLMainString( commandline)  charp_ct commandline;
#endif /* MLINTERFACE >= 3 */
#endif
{
	return _MLMain( (charpp_ct)0, (charpp_ct)0, commandline);
}

#if MLPROTOTYPES
int MLMainArgv( char** argv, char** argv_end) /* note not FAR pointers */
#else
int MLMainArgv( argv, argv_end)  char **argv, **argv_end;
#endif
{   
	static char FAR * far_argv[128];
	int count = 0;
	
	while(argv < argv_end)
		far_argv[count++] = *argv++;
		 
	return _MLMain( far_argv, far_argv + count, (charp_ct)0);

}

#if MLPROTOTYPES
#if MLINTERFACE >= 3
int MLMain( int argc, char **argv)
#else
int MLMain( int argc, charpp_ct argv)
#endif /* MLINTERFACE >= 3 */
#else
#if MLINTERFACE >= 3
int MLMain( argc, argv) int argc; char **argv;
#else
int MLMain( argc, argv) int argc; charpp_ct argv;
#endif /* MLINTERFACE >= 3 */
#endif
{
#if MLINTERFACE >= 3
 	return _MLMain( argv, argv + argc, (char *)0);
#else
 	return _MLMain( argv, argv + argc, (charp_ct)0);
#endif /* MLINTERFACE >= 3 */
}
 
